<template>
  <div class="container">
    <h2>New RelGameClassSkill</h2>
    <b-form-input
      v-model="game_class_id"
      required
      placeholder="game class id"
      type="number">
    </b-form-input>
    <small>In case you don't know the game class id, visit <nuxt-link to="/admin/game_classes">game_classes</nuxt-link></small>
    <b-form-input
      v-model="skill_id"
      required
      placeholder="skill id"
      type="number">
    </b-form-input>
    <small>In case you don't know the skill id, visit <nuxt-link to="/admin/skills">skills</nuxt-link></small>
    <b-form-input
      v-model="level"
      required
      placeholder="level"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      game_class_id: '',
      skill_id: '',
      level: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.game_class_id * this.skill_id * this.level > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        rel_class_skill: {
          game_class_id: this.game_class_id,
          skill_id: this.skill_id,
          level: this.level
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/rel_class_skills',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.game_class_id = '';
      this.skill_id = '';
      this.level = '';
      this.error = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
